AI Suite — API Reference

Analytics, recommendations, search, and more

59 endpoints across 8 tags.

Search

GET /search/v2/indices/{indexId}/query — Full-text items search

/api-reference/ai-search#tag/Search/operation/SearchFullTextGet

Retrieves items that match a full-text query from a search index or a suggestion index. The results can be filtered and sorted.


API consumers: AI API key (legacy), Web SDK Tracker, Workspace (Business Profile)

API key permission required: ITEMS_SEARCH_SEARCH_READ

Parameters

NameInTypeRequiredDescription
queryquerystringrequiredQuery text to use in the search
indexIdpathstringrequiredID of the index to be used in the search operation
clientUUIDquerystringoptionalUUID of the profile for which the search is performed
personalizequerybooleanoptionalIf set to false, the search result is not personalized.
correlationIdquerystringoptionalCorrelation ID for pagination. If a search with the ID was performed recently (last 10 minutes), the cached results will be used. Do not send this if sortBy/filters/sorting order, etc. have changed - the cached results may have different order or may match different filters.
searchIdquerystringoptionalDEPRECATED - use correlationId instead Search ID for pagination. If a search with the ID was performed recently (last 10 minutes), the cached results will be used. Do not send this if sortBy/filters/sorting order, etc. have changed - the cached results may have different order or may match different filters.
sortByMetricqueryenum<"TransactionsPopularity", "PageVisitsPopularity">optionalIMPORTANT: Sorting disables boosting, elastic filters, and promoting search results. Name of the metric by which the data will be sorted.
sortByGeoPointquerystringoptionalIMPORTANT: Sorting disables boosting, elastic filters, and promoting search results. Geo-point ({latitude},{longitude}) for data sorting. Results are sorted by distance from this point. ordering: asc means "closest first".'
filterGeoPointsqueryarray<string>optionalThe definition of a geographical area to filter by. Given one geo-point, the results will be limited to a radius around a point. To override the default radius (1000 meters), provide the filterAroundRadius parameter. Example input: ["34.052235,-118.243685"] Given two geo-points, the results will be limited to a rectangular area. Example input: ["50,-100", "25,150"] Given three or more geo-points, the results will be limited to a polygonal area. Example input: ["50,0", "40,20", "-20,10"]
filterAroundRadiusqueryintegeroptionalRadius in meters to be used when filtering using geo-location. Can only be used when filtering by a single geo-point.
filtersquerystringoptionalIQL query string. For details, see the Help Center.
facetsqueryarray<string>optionalA list of attributes for which facets will be returned. A single * value matches all facetable attributes. A single auto value enables automatic facet selection based on the result set — the system picks the most relevant facets using the index's dynamicFacets configuration. To determine which groups of facets should be returned, use the includeFacets parameter.
facetsSizequeryintegeroptionalDetermines how many items will be used for facets aggregation.
maxValuesPerFacetqueryintegeroptionalDetermines how many values will be retrieved per facet.
caseSensitiveFacetValuesquerybooleanoptionalSpecifies whether facets aggregation should be case sensitive.
displayAttributesqueryarray<string>optionalList of ad hoc attributes that will be returned for each found item
contextqueryarray<string>optionalList of context strings for a search query
includeFacetsqueryenum<"all", "filtered", "unfiltered", "none">optionalDetermines which groups of facets will be returned: both filtered and unfiltered; just filtered; just unfiltered; or no group at at all. To determine which attributes should be returned as facets in each group, use the facets parameter.
facetsOrderByqueryenum<"coverage", "name">optionalControls the ordering of facets in the response.When facets=auto, the default ordering is by coverage (most relevant facets first).When facets are specified explicitly, the default ordering is by name.When two facets have equal coverage, ties are resolved by name.
pagequeryintegeroptionalPage number to return for pagination. The first page has the index 1.
limitqueryintegeroptionalThe number of items to return per page
sortByquerystringoptionalIMPORTANT: Sorting disables boosting, elastic filters, and promoting search results. Name of the attribute by which the data will be sorted.
orderingqueryenum<"desc", "asc">optionalSorting order
includeMetaquerybooleanoptionalWhen true, pagination metadata is included in the response body. When false, the data is included in the response headers: Link: links to neighbors, first, and last pages in pagination. X-Pagination-Total-Count: total number of items on all pages X-Pagination-Total-Pages: total number of pages X-Pagination-Page: current page X-Pagination-Limit: maximum number of items on a page X-Pagination-Sorted-By: parameter that the items were sorted by X-Pagination-Ordering: sorting direction
distinctFilterquerystringoptionalDistinctFilter JSON as an URL-encoded string
ignoreQueryRulesquerybooleanoptionalIf set to true, query rules are not applied.
excludeQueryRulesqueryarray<integer>optionalList of query rules that will not be applied.
disableQueryClassificationquerybooleanoptionalIf set to true, query classification is not applied.
disableDynamicRerankerquerybooleanoptionalIf set to true, dynamic reranker is not applied.
paramsqueryarray<string>optionalList of extra params that will be added to the item.search event. They must be in the name:value format. The total size must not exceed 500 bytes when written as a JSON object.

Responses

StatusDescription
200 application/jsonSearch result
500 application/jsonService not available

Example request (cURL)

curl --request GET \
  --url 'https://api.synerise.com/search/v2/indices/%7BindexId%7D/query?query=SOME_STRING_VALUE&clientUUID=SOME_STRING_VALUE&personalize=SOME_BOOLEAN_VALUE&correlationId=SOME_STRING_VALUE&searchId=SOME_STRING_VALUE&sortByMetric=SOME_STRING_VALUE&sortByGeoPoint=34.052235%2C-118.243685&filterGeoPoints=34.052235%2C-118.243685&filterGeoPoints=15.0%2C65.0&filterAroundRadius=5000&filters=SOME_STRING_VALUE&facets=SOME_ARRAY_VALUE&facetsSize=SOME_INTEGER_VALUE&maxValuesPerFacet=SOME_INTEGER_VALUE&caseSensitiveFacetValues=SOME_BOOLEAN_VALUE&displayAttributes=title&displayAttributes=price&context=mobile&context=listing&includeFacets=SOME_STRING_VALUE&facetsOrderBy=SOME_STRING_VALUE&page=4&limit=10&sortBy=SOME_STRING_VALUE&ordering=SOME_STRING_VALUE&includeMeta=SOME_BOOLEAN_VALUE&distinctFilter=%7B%22attribute%22%3A%20%22color%22%2C%20%22maxNumItems%22%3A%203%7D&ignoreQueryRules=SOME_BOOLEAN_VALUE&excludeQueryRules=2&excludeQueryRules=5&disableQueryClassification=SOME_BOOLEAN_VALUE&disableDynamicReranker=SOME_BOOLEAN_VALUE&params=source%3Amobile' \
  --header 'Authorization: Bearer REPLACE_BEARER_TOKEN'

POST /search/v2/indices/{indexId}/query — Full-text items search

/api-reference/ai-search#tag/Search/operation/SearchFullTextPost

Retrieves items that match a full-text query from a search index or a suggestion index. The results can be filtered and sorted.


API consumers: AI API key (legacy), Web SDK Tracker, Workspace (Business Profile)

API key permission required: ITEMS_SEARCH_SEARCH_READ

Parameters

NameInTypeRequiredDescription
indexIdpathstringrequiredID of the index to be used in the search operation

Request body (required)

application/json · items-search-FullTextSearchRequest

Request for performing full-text search

FieldTypeRequiredDescription
querystringrequiredQuery text to use in the search
pageintegeroptionalPage number to return for pagination. The first page has the index 1.
limitintegeroptionalThe number of items to return per page
sortBystringoptionalIMPORTANT: Sorting disables boosting, elastic filters, and promoting search results. Name of the attribute by which the data will be sorted.
orderingenum<"desc", "asc">optionalSorting order
includeMetabooleanoptionalWhen true, pagination metadata is included in the response body. When false, the data is included in the response headers: Link: links to neighbors, first, and last pages in pagination. X-Pagination-Total-Count: total number of items on all pages X-Pagination-Total-Pages: total number of pages X-Pagination-Page: current page X-Pagination-Limit: maximum number of items on a page X-Pagination-Sorted-By: parameter that the items were sorted by X-Pagination-Ordering: sorting direction
clientUUIDstringoptionalUUID of the profile for which the search is performed
personalizebooleanoptionalIf set to false, the search result is not personalized.
correlationIdstringoptionalCorrelation ID for pagination. If a search with the ID was performed recently (last 10 minutes), the cached results will be used. Do not send this if sortBy/filters/sorting order, etc. have changed - the cached results may have different order or may match different filters.
searchIdstringoptionalDEPRECATED - use correlationId instead Search ID for pagination. If a search with the ID was performed recently (last 10 minutes), the cached results will be used. Do not send this if sortBy/filters/sorting order, etc. have changed - the cached results may have different order or may match different filters.
sortByMetricenum<"TransactionsPopularity", "PageVisitsPopularity">optionalIMPORTANT: Sorting disables boosting, elastic filters, and promoting search results. Name of the metric by which the data will be sorted.
sortByGeoPointsstringoptionalIMPORTANT: Sorting disables boosting, elastic filters, and promoting search results. Geo-point ({latitude},{longitude}) for data sorting. Results are sorted by distance from this point. ordering: asc means "closest first".'
filterGeoPointsarray<string>optionalThe definition of a geographical area to filter by. Given one geo-point, the results will be limited to a radius around a point. To override the default radius (1000 meters), provide the filterAroundRadius parameter. Example input: ["34.052235,-118.243685"] Given two geo-points, the results will be limited to a rectangular area. Example input: ["50,-100", "25,150"] Given three or more geo-points, the results will be limited to a polygonal area. Example input: ["50,0", "40,20", "-20,10"]
filterAroundRadiusintegeroptionalRadius in meters to be used when filtering using geo-location. Can only be used when filtering by a single geo-point.
filtersstringoptionalIQL query string. For details, see the Help Center.
facetsarray<string>optionalA list of attributes for which facets will be returned. A single * value matches all facetable attributes. A single auto value enables automatic facet selection based on the result set — the system picks the most relevant facets using the index's dynamicFacets configuration. To determine which groups of facets should be returned, use the includeFacets parameter.
customFilteredFacetsobjectoptionalA key-value map that takes attributes as keys and IQL query strings as values. For each key a facet is returned that includes only the items filtered by the provided IQL query string.
facetsSizeintegeroptionalDetermines how many items will be used for facets aggregation.
maxValuesPerFacetintegeroptionalDetermines how many values will be retrieved per facet.
caseSensitiveFacetValuesbooleanoptionalSpecifies whether facets aggregation should be case sensitive.
includeFacetsenum<"all", "filtered", "unfiltered", "none">optionalDetermines which groups of facets will be returned: both filtered and unfiltered; just filtered; just unfiltered; or no group at at all. To determine which attributes should be returned as facets in each group, use the facets and customFilteredFacets parameters.
facetsOrderByenum<"coverage", "name">optionalControls the ordering of facets in the response.When facets=auto, the default ordering is by coverage (most relevant facets first).When facets are specified explicitly, the default ordering is by name.When two facets have equal coverage, ties are resolved by name.
contextarray<string>optionalList of context strings for a search query
displayAttributesarray<string>optionalList of ad hoc attributes that will be returned for each found item
distinctFilterobjectoptionalDistinct filters regulate how many items with the same value of a particular attribute can be returned.
ignoreQueryRulesbooleanoptionalIf set to true, query rules are not applied.
excludeQueryRulesarray<integer>optionalList of query rules that will not be applied.
paramsobjectoptionalExtra parameters that will be added to the item.search event. The total size must not exceed 500 bytes.
disableQueryClassificationbooleanoptionalIf set to true, query classification is not applied.
disableDynamicRerankerbooleanoptionalIf set to true, q dynamic reranker is not applied.

Responses

StatusDescription
200 application/jsonSearch result
500 application/jsonService not available

Example request (cURL)

curl --request POST \
  --url https://api.synerise.com/search/v2/indices/%7BindexId%7D/query \
  --header 'Authorization: Bearer REPLACE_BEARER_TOKEN' \
  --header 'content-type: application/json' \
  --data '{"query":"string","page":0,"limit":10,"sortBy":"string","ordering":"desc","includeMeta":true,"clientUUID":"string","personalize":true,"correlationId":"string","searchId":"string","sortByMetric":"TransactionsPopularity","sortByGeoPoints":"34.052235,-118.243685","filterGeoPoints":["34.052235,-118.243685","15.0,65.0"],"filterAroundRadius":2000,"filters":"string","facets":["string"],"customFilteredFacets":{"brand":"price > 100","price":"brand == foo"},"facetsSize":2000,"maxValuesPerFacet":50,"caseSensitiveFacetValues":false,"includeFacets":"all","facetsOrderBy":"coverage","context":["mobile","listing"],"displayAttributes":["title","price"],"distinctFilter":{"attribute":"string","maxNumItems":1,"levelRangeModifier":0},"ignoreQueryRules":false,"excludeQueryRules":[2,5],"params":{"source":"mobile"},"disableQueryClassification":false,"disableDynamicReranker":false}'

GET /search/v2/indices/{indexId}/query/explain — Explained full-text items search

/api-reference/ai-search#tag/Search/operation/SearchFullTextGetWithExplanation

Retrieves items that match a full-text query from a search index or a suggestion index. The results can be filtered and sorted. The response contains an explanation of the factors that influenced the result.


API consumers: AI API key (legacy), Web SDK Tracker, Workspace (Business Profile)

API key permission required: ITEMS_SEARCH_SEARCH_READ

Parameters

NameInTypeRequiredDescription
queryquerystringrequiredQuery text to use in the search
indexIdpathstringrequiredID of the index to be used in the search operation
clientUUIDquerystringoptionalUUID of the profile for which the search is performed
personalizequerybooleanoptionalIf set to false, the search result is not personalized.
correlationIdquerystringoptionalCorrelation ID for pagination. If a search with the ID was performed recently (last 10 minutes), the cached results will be used. Do not send this if sortBy/filters/sorting order, etc. have changed - the cached results may have different order or may match different filters.
searchIdquerystringoptionalDEPRECATED - use correlationId instead Search ID for pagination. If a search with the ID was performed recently (last 10 minutes), the cached results will be used. Do not send this if sortBy/filters/sorting order, etc. have changed - the cached results may have different order or may match different filters.
sortByMetricqueryenum<"TransactionsPopularity", "PageVisitsPopularity">optionalIMPORTANT: Sorting disables boosting, elastic filters, and promoting search results. Name of the metric by which the data will be sorted.
sortByGeoPointquerystringoptionalIMPORTANT: Sorting disables boosting, elastic filters, and promoting search results. Geo-point ({latitude},{longitude}) for data sorting. Results are sorted by distance from this point. ordering: asc means "closest first".'
filterGeoPointsqueryarray<string>optionalThe definition of a geographical area to filter by. Given one geo-point, the results will be limited to a radius around a point. To override the default radius (1000 meters), provide the filterAroundRadius parameter. Example input: ["34.052235,-118.243685"] Given two geo-points, the results will be limited to a rectangular area. Example input: ["50,-100", "25,150"] Given three or more geo-points, the results will be limited to a polygonal area. Example input: ["50,0", "40,20", "-20,10"]
filterAroundRadiusqueryintegeroptionalRadius in meters to be used when filtering using geo-location. Can only be used when filtering by a single geo-point.
filtersquerystringoptionalIQL query string. For details, see the Help Center.
facetsqueryarray<string>optionalA list of attributes for which facets will be returned. A single * value matches all facetable attributes. A single auto value enables automatic facet selection based on the result set — the system picks the most relevant facets using the index's dynamicFacets configuration. To determine which groups of facets should be returned, use the includeFacets parameter.
facetsSizequeryintegeroptionalDetermines how many items will be used for facets aggregation.
maxValuesPerFacetqueryintegeroptionalDetermines how many values will be retrieved per facet.
caseSensitiveFacetValuesquerybooleanoptionalSpecifies whether facets aggregation should be case sensitive.
displayAttributesqueryarray<string>optionalList of ad hoc attributes that will be returned for each found item
contextqueryarray<string>optionalList of context strings for a search query
includeFacetsqueryenum<"all", "filtered", "unfiltered", "none">optionalDetermines which groups of facets will be returned: both filtered and unfiltered; just filtered; just unfiltered; or no group at at all. To determine which attributes should be returned as facets in each group, use the facets parameter.
facetsOrderByqueryenum<"coverage", "name">optionalControls the ordering of facets in the response.When facets=auto, the default ordering is by coverage (most relevant facets first).When facets are specified explicitly, the default ordering is by name.When two facets have equal coverage, ties are resolved by name.
pagequeryintegeroptionalPage number to return for pagination. The first page has the index 1.
limitqueryintegeroptionalThe number of items to return per page
sortByquerystringoptionalIMPORTANT: Sorting disables boosting, elastic filters, and promoting search results. Name of the attribute by which the data will be sorted.
orderingqueryenum<"desc", "asc">optionalSorting order
includeMetaquerybooleanoptionalWhen true, pagination metadata is included in the response body. When false, the data is included in the response headers: Link: links to neighbors, first, and last pages in pagination. X-Pagination-Total-Count: total number of items on all pages X-Pagination-Total-Pages: total number of pages X-Pagination-Page: current page X-Pagination-Limit: maximum number of items on a page X-Pagination-Sorted-By: parameter that the items were sorted by X-Pagination-Ordering: sorting direction
distinctFilterquerystringoptionalDistinctFilter JSON as an URL-encoded string
ignoreQueryRulesquerybooleanoptionalIf set to true, query rules are not applied.
disableQueryClassificationquerybooleanoptionalIf set to true, query classification is not applied.
disableDynamicRerankerquerybooleanoptionalIf set to true, dynamic reranker is not applied.
excludeQueryRulesqueryarray<integer>optionalList of query rules that will not be applied.
crossWorkspaceModeEnabledquerybooleanoptionalIf set, overrides the cross-workspace mode from the index configuration. When true, cross-workspace personalization is enabled. When false, it is disabled.
paramsqueryarray<string>optionalList of extra params that will be added to the item.search event. They must be in the name:value format. The total size must not exceed 500 bytes when written as a JSON object.

Responses

StatusDescription
200 application/jsonSearch result
500 application/jsonService not available

Example request (cURL)

curl --request GET \
  --url 'https://api.synerise.com/search/v2/indices/%7BindexId%7D/query/explain?query=SOME_STRING_VALUE&clientUUID=SOME_STRING_VALUE&personalize=SOME_BOOLEAN_VALUE&correlationId=SOME_STRING_VALUE&searchId=SOME_STRING_VALUE&sortByMetric=SOME_STRING_VALUE&sortByGeoPoint=34.052235%2C-118.243685&filterGeoPoints=34.052235%2C-118.243685&filterGeoPoints=15.0%2C65.0&filterAroundRadius=5000&filters=SOME_STRING_VALUE&facets=SOME_ARRAY_VALUE&facetsSize=SOME_INTEGER_VALUE&maxValuesPerFacet=SOME_INTEGER_VALUE&caseSensitiveFacetValues=SOME_BOOLEAN_VALUE&displayAttributes=title&displayAttributes=price&context=mobile&context=listing&includeFacets=SOME_STRING_VALUE&facetsOrderBy=SOME_STRING_VALUE&page=4&limit=10&sortBy=SOME_STRING_VALUE&ordering=SOME_STRING_VALUE&includeMeta=SOME_BOOLEAN_VALUE&distinctFilter=%7B%22attribute%22%3A%20%22color%22%2C%20%22maxNumItems%22%3A%203%7D&ignoreQueryRules=SOME_BOOLEAN_VALUE&disableQueryClassification=SOME_BOOLEAN_VALUE&disableDynamicReranker=SOME_BOOLEAN_VALUE&excludeQueryRules=2&excludeQueryRules=5&crossWorkspaceModeEnabled=SOME_BOOLEAN_VALUE&params=source%3Amobile' \
  --header 'Authorization: Bearer REPLACE_BEARER_TOKEN'

POST /search/v2/indices/{indexId}/query/explain — Explained full-text items search

/api-reference/ai-search#tag/Search/operation/SearchFullTextPostWithExplanation

Retrieves items that match a full-text query from a search index or a suggestion index. The results can be filtered and sorted. The response contains an explanation of the factors that influenced the result.


API consumers: AI API key (legacy), Web SDK Tracker, Workspace (Business Profile)

API key permission required: ITEMS_SEARCH_SEARCH_READ

Parameters

NameInTypeRequiredDescription
indexIdpathstringrequiredID of the index to be used in the search operation

Request body (required)

application/json · object

Request for performing full-text search with explanation

FieldTypeRequiredDescription
querystringrequiredQuery text to use in the search
pageintegeroptionalPage number to return for pagination. The first page has the index 1.
limitintegeroptionalThe number of items to return per page
sortBystringoptionalIMPORTANT: Sorting disables boosting, elastic filters, and promoting search results. Name of the attribute by which the data will be sorted.
orderingenum<"desc", "asc">optionalSorting order
includeMetabooleanoptionalWhen true, pagination metadata is included in the response body. When false, the data is included in the response headers: Link: links to neighbors, first, and last pages in pagination. X-Pagination-Total-Count: total number of items on all pages X-Pagination-Total-Pages: total number of pages X-Pagination-Page: current page X-Pagination-Limit: maximum number of items on a page X-Pagination-Sorted-By: parameter that the items were sorted by X-Pagination-Ordering: sorting direction
clientUUIDstringoptionalUUID of the profile for which the search is performed
personalizebooleanoptionalIf set to false, the search result is not personalized.
correlationIdstringoptionalCorrelation ID for pagination. If a search with the ID was performed recently (last 10 minutes), the cached results will be used. Do not send this if sortBy/filters/sorting order, etc. have changed - the cached results may have different order or may match different filters.
searchIdstringoptionalDEPRECATED - use correlationId instead Search ID for pagination. If a search with the ID was performed recently (last 10 minutes), the cached results will be used. Do not send this if sortBy/filters/sorting order, etc. have changed - the cached results may have different order or may match different filters.
sortByMetricenum<"TransactionsPopularity", "PageVisitsPopularity">optionalIMPORTANT: Sorting disables boosting, elastic filters, and promoting search results. Name of the metric by which the data will be sorted.
sortByGeoPointsstringoptionalIMPORTANT: Sorting disables boosting, elastic filters, and promoting search results. Geo-point ({latitude},{longitude}) for data sorting. Results are sorted by distance from this point. ordering: asc means "closest first".'
filterGeoPointsarray<string>optionalThe definition of a geographical area to filter by. Given one geo-point, the results will be limited to a radius around a point. To override the default radius (1000 meters), provide the filterAroundRadius parameter. Example input: ["34.052235,-118.243685"] Given two geo-points, the results will be limited to a rectangular area. Example input: ["50,-100", "25,150"] Given three or more geo-points, the results will be limited to a polygonal area. Example input: ["50,0", "40,20", "-20,10"]
filterAroundRadiusintegeroptionalRadius in meters to be used when filtering using geo-location. Can only be used when filtering by a single geo-point.
filtersstringoptionalIQL query string. For details, see the Help Center.
facetsarray<string>optionalA list of attributes for which facets will be returned. A single * value matches all facetable attributes. A single auto value enables automatic facet selection based on the result set — the system picks the most relevant facets using the index's dynamicFacets configuration. To determine which groups of facets should be returned, use the includeFacets parameter.
customFilteredFacetsobjectoptionalA key-value map that takes attributes as keys and IQL query strings as values. For each key a facet is returned that includes only the items filtered by the provided IQL query string.
facetsSizeintegeroptionalDetermines how many items will be used for facets aggregation.
maxValuesPerFacetintegeroptionalDetermines how many values will be retrieved per facet.
caseSensitiveFacetValuesbooleanoptionalSpecifies whether facets aggregation should be case sensitive.
includeFacetsenum<"all", "filtered", "unfiltered", "none">optionalDetermines which groups of facets will be returned: both filtered and unfiltered; just filtered; just unfiltered; or no group at at all. To determine which attributes should be returned as facets in each group, use the facets and customFilteredFacets parameters.
facetsOrderByenum<"coverage", "name">optionalControls the ordering of facets in the response.When facets=auto, the default ordering is by coverage (most relevant facets first).When facets are specified explicitly, the default ordering is by name.When two facets have equal coverage, ties are resolved by name.
contextarray<string>optionalList of context strings for a search query
displayAttributesarray<string>optionalList of ad hoc attributes that will be returned for each found item
distinctFilterobjectoptionalDistinct filters regulate how many items with the same value of a particular attribute can be returned.
ignoreQueryRulesbooleanoptionalIf set to true, query rules are not applied.
excludeQueryRulesarray<integer>optionalList of query rules that will not be applied.
paramsobjectoptionalExtra parameters that will be added to the item.search event. The total size must not exceed 500 bytes.
disableQueryClassificationbooleanoptionalIf set to true, query classification is not applied.
disableDynamicRerankerbooleanoptionalIf set to true, q dynamic reranker is not applied.
crossWorkspaceModeobjectoptionalCross-workspace personalization mode. When provided, overrides the index configuration setting.

Responses

StatusDescription
200 application/jsonSearch result
500 application/jsonService not available

Example request (cURL)

curl --request POST \
  --url https://api.synerise.com/search/v2/indices/%7BindexId%7D/query/explain \
  --header 'Authorization: Bearer REPLACE_BEARER_TOKEN' \
  --header 'content-type: application/json' \
  --data '{"query":"string","page":0,"limit":10,"sortBy":"string","ordering":"desc","includeMeta":true,"clientUUID":"string","personalize":true,"correlationId":"string","searchId":"string","sortByMetric":"TransactionsPopularity","sortByGeoPoints":"34.052235,-118.243685","filterGeoPoints":["34.052235,-118.243685","15.0,65.0"],"filterAroundRadius":2000,"filters":"string","facets":["string"],"customFilteredFacets":{"brand":"price > 100","price":"brand == foo"},"facetsSize":2000,"maxValuesPerFacet":50,"caseSensitiveFacetValues":false,"includeFacets":"all","facetsOrderBy":"coverage","context":["mobile","listing"],"displayAttributes":["title","price"],"distinctFilter":{"attribute":"string","maxNumItems":1,"levelRangeModifier":0},"ignoreQueryRules":false,"excludeQueryRules":[2,5],"params":{"source":"mobile"},"disableQueryClassification":false,"disableDynamicReranker":false,"crossWorkspaceMode":{"enabled":true}}'

GET /search/v2/indices/{indexId}/autocomplete — Autocomplete items search

/api-reference/ai-search#tag/Search/operation/SearchAutocompleteGet

Retrieves items that match a query from a search index or a suggestion index. The results can be filtered and sorted. The results of this search type are not cached.


API consumers: AI API key (legacy), Web SDK Tracker, Workspace (Business Profile)

API key permission required: ITEMS_SEARCH_SEARCH_READ

Parameters

NameInTypeRequiredDescription
queryquerystringrequiredQuery text to use in the search
indexIdpathstringrequiredID of the index to be used in the search operation
clientUUIDquerystringoptionalUUID of the profile for which the search is performed
personalizequerybooleanoptionalIf set to false, the search result is not personalized.
sortByMetricqueryenum<"TransactionsPopularity", "PageVisitsPopularity">optionalIMPORTANT: Sorting disables boosting, elastic filters, and promoting search results. Name of the metric by which the data will be sorted.
sortByGeoPointquerystringoptionalIMPORTANT: Sorting disables boosting, elastic filters, and promoting search results. Geo-point ({latitude},{longitude}) for data sorting. Results are sorted by distance from this point. ordering: asc means "closest first".'
filterGeoPointsqueryarray<string>optionalThe definition of a geographical area to filter by. Given one geo-point, the results will be limited to a radius around a point. To override the default radius (1000 meters), provide the filterAroundRadius parameter. Example input: ["34.052235,-118.243685"] Given two geo-points, the results will be limited to a rectangular area. Example input: ["50,-100", "25,150"] Given three or more geo-points, the results will be limited to a polygonal area. Example input: ["50,0", "40,20", "-20,10"]
filterAroundRadiusqueryintegeroptionalRadius in meters to be used when filtering using geo-location. Can only be used when filtering by a single geo-point.
filtersquerystringoptionalIQL query string. For details, see the Help Center.
facetsqueryarray<string>optionalA list of attributes for which facets will be returned. A single * value matches all facetable attributes. A single auto value enables automatic facet selection based on the result set — the system picks the most relevant facets using the index's dynamicFacets configuration. To determine which groups of facets should be returned, use the includeFacets parameter.
facetsSizequeryintegeroptionalDetermines how many items will be used for facets aggregation.
maxValuesPerFacetqueryintegeroptionalDetermines how many values will be retrieved per facet.
caseSensitiveFacetValuesquerybooleanoptionalSpecifies whether facets aggregation should be case sensitive.
displayAttributesqueryarray<string>optionalList of ad hoc attributes that will be returned for each found item
contextqueryarray<string>optionalList of context strings for a search query
includeFacetsqueryenum<"all", "filtered", "unfiltered", "none">optionalDetermines which groups of facets will be returned: both filtered and unfiltered; just filtered; just unfiltered; or no group at at all. To determine which attributes should be returned as facets in each group, use the facets parameter.
facetsOrderByqueryenum<"coverage", "name">optionalControls the ordering of facets in the response.When facets=auto, the default ordering is by coverage (most relevant facets first).When facets are specified explicitly, the default ordering is by name.When two facets have equal coverage, ties are resolved by name.
pagequeryintegeroptionalPage number to return for pagination. The first page has the index 1.
limitqueryintegeroptionalThe number of items to return per page
sortByquerystringoptionalIMPORTANT: Sorting disables boosting, elastic filters, and promoting search results. Name of the attribute by which the data will be sorted.
orderingqueryenum<"desc", "asc">optionalSorting order
includeMetaquerybooleanoptionalWhen true, pagination metadata is included in the response body. When false, the data is included in the response headers: Link: links to neighbors, first, and last pages in pagination. X-Pagination-Total-Count: total number of items on all pages X-Pagination-Total-Pages: total number of pages X-Pagination-Page: current page X-Pagination-Limit: maximum number of items on a page X-Pagination-Sorted-By: parameter that the items were sorted by X-Pagination-Ordering: sorting direction
distinctFilterquerystringoptionalDistinctFilter JSON as an URL-encoded string
ignoreQueryRulesquerybooleanoptionalIf set to true, query rules are not applied.
excludeQueryRulesqueryarray<integer>optionalList of query rules that will not be applied.
paramsqueryarray<string>optionalList of extra params that will be added to the item.search event. They must be in the name:value format. The total size must not exceed 500 bytes when written as a JSON object.
disableQueryClassificationquerybooleanoptionalIf set to true, query classification is not applied.
disableDynamicRerankerquerybooleanoptionalIf set to true, dynamic reranker is not applied.

Responses

StatusDescription
200 application/jsonSearch result
500 application/jsonService not available

Example request (cURL)

curl --request GET \
  --url 'https://api.synerise.com/search/v2/indices/%7BindexId%7D/autocomplete?query=SOME_STRING_VALUE&clientUUID=SOME_STRING_VALUE&personalize=SOME_BOOLEAN_VALUE&sortByMetric=SOME_STRING_VALUE&sortByGeoPoint=34.052235%2C-118.243685&filterGeoPoints=34.052235%2C-118.243685&filterGeoPoints=15.0%2C65.0&filterAroundRadius=5000&filters=SOME_STRING_VALUE&facets=SOME_ARRAY_VALUE&facetsSize=SOME_INTEGER_VALUE&maxValuesPerFacet=SOME_INTEGER_VALUE&caseSensitiveFacetValues=SOME_BOOLEAN_VALUE&displayAttributes=title&displayAttributes=price&context=mobile&context=listing&includeFacets=SOME_STRING_VALUE&facetsOrderBy=SOME_STRING_VALUE&page=4&limit=10&sortBy=SOME_STRING_VALUE&ordering=SOME_STRING_VALUE&includeMeta=SOME_BOOLEAN_VALUE&distinctFilter=%7B%22attribute%22%3A%20%22color%22%2C%20%22maxNumItems%22%3A%203%7D&ignoreQueryRules=SOME_BOOLEAN_VALUE&excludeQueryRules=2&excludeQueryRules=5&params=source%3Amobile&disableQueryClassification=SOME_BOOLEAN_VALUE&disableDynamicReranker=SOME_BOOLEAN_VALUE' \
  --header 'Authorization: Bearer REPLACE_BEARER_TOKEN'

POST /search/v2/indices/{indexId}/autocomplete — Autocomplete items search

/api-reference/ai-search#tag/Search/operation/SearchAutocompletePost

Retrieves items that match a query from a search index or a suggestion index. The results can be filtered and sorted. The results of this search type are not cached.


API consumers: AI API key (legacy), Web SDK Tracker, Workspace (Business Profile)

API key permission required: ITEMS_SEARCH_SEARCH_READ

Parameters

NameInTypeRequiredDescription
indexIdpathstringrequiredID of the index to be used in the search operation

Request body (required)

application/json · items-search-AutocompleteRequest

Request for performing an autocomplete search

FieldTypeRequiredDescription
querystringrequiredQuery text to use in the search
pageintegeroptionalPage number to return for pagination. The first page has the index 1.
limitintegeroptionalThe number of items to return per page
sortBystringoptionalIMPORTANT: Sorting disables boosting, elastic filters, and promoting search results. Name of the attribute by which the data will be sorted.
orderingenum<"desc", "asc">optionalSorting order
includeMetabooleanoptionalWhen true, pagination metadata is included in the response body. When false, the data is included in the response headers: Link: links to neighbors, first, and last pages in pagination. X-Pagination-Total-Count: total number of items on all pages X-Pagination-Total-Pages: total number of pages X-Pagination-Page: current page X-Pagination-Limit: maximum number of items on a page X-Pagination-Sorted-By: parameter that the items were sorted by X-Pagination-Ordering: sorting direction
clientUUIDstringoptionalUUID of the profile for which the search is performed
sortByMetricenum<"TransactionsPopularity", "PageVisitsPopularity">optionalIMPORTANT: Sorting disables boosting, elastic filters, and promoting search results. Name of the metric by which the data will be sorted.
sortByGeoPointsstringoptionalIMPORTANT: Sorting disables boosting, elastic filters, and promoting search results. Geo-point ({latitude},{longitude}) for data sorting. Results are sorted by distance from this point. ordering: asc means "closest first".'
filterGeoPointsarray<string>optionalThe definition of a geographical area to filter by. Given one geo-point, the results will be limited to a radius around a point. To override the default radius (1000 meters), provide the filterAroundRadius parameter. Example input: ["34.052235,-118.243685"] Given two geo-points, the results will be limited to a rectangular area. Example input: ["50,-100", "25,150"] Given three or more geo-points, the results will be limited to a polygonal area. Example input: ["50,0", "40,20", "-20,10"]
filterAroundRadiusintegeroptionalRadius in meters to be used when filtering using geo-location. Can only be used when filtering by a single geo-point.
filtersstringoptionalIQL query string. For details, see the Help Center.
facetsarray<string>optionalA list of attributes for which facets will be returned. A single * value matches all facetable attributes. A single auto value enables automatic facet selection based on the result set — the system picks the most relevant facets using the index's dynamicFacets configuration. To determine which groups of facets should be returned, use the includeFacets parameter.
customFilteredFacetsobjectoptionalA key-value map that takes attributes as keys and IQL query strings as values. For each key a facet is returned that includes only the items filtered by the provided IQL query string.
facetsSizeintegeroptionalDetermines how many items will be used for facets aggregation.
maxValuesPerFacetintegeroptionalDetermines how many values will be retrieved per facet.
caseSensitiveFacetValuesbooleanoptionalSpecifies whether facets aggregation should be case sensitive.
includeFacetsenum<"all", "filtered", "unfiltered", "none">optionalDetermines which groups of facets will be returned: both filtered and unfiltered; just filtered; just unfiltered; or no group at at all. To determine which attributes should be returned as facets in each group, use the facets and customFilteredFacets parameters.
facetsOrderByenum<"coverage", "name">optionalControls the ordering of facets in the response.When facets=auto, the default ordering is by coverage (most relevant facets first).When facets are specified explicitly, the default ordering is by name.When two facets have equal coverage, ties are resolved by name.
contextarray<string>optionalList of context strings for a search query
displayAttributesarray<string>optionalList of ad hoc attributes that will be returned for each found item
distinctFilterobjectoptionalDistinct filters regulate how many items with the same value of a particular attribute can be returned.
ignoreQueryRulesbooleanoptionalIf set to true, query rules are not applied.
excludeQueryRulesarray<integer>optionalList of query rules that will not be applied.
paramsobjectoptionalExtra parameters that will be added to the item.search event. The total size must not exceed 500 bytes.
disableQueryClassificationbooleanoptionalIf set to true, query classification is not applied.
disableDynamicRerankerbooleanoptionalIf set to true, q dynamic reranker is not applied.

Responses

StatusDescription
200 application/jsonSearch result
500 application/jsonService not available

Example request (cURL)

curl --request POST \
  --url https://api.synerise.com/search/v2/indices/%7BindexId%7D/autocomplete \
  --header 'Authorization: Bearer REPLACE_BEARER_TOKEN' \
  --header 'content-type: application/json' \
  --data '{"query":"string","page":0,"limit":10,"sortBy":"string","ordering":"desc","includeMeta":true,"clientUUID":"string","sortByMetric":"TransactionsPopularity","sortByGeoPoints":"34.052235,-118.243685","filterGeoPoints":["34.052235,-118.243685","15.0,65.0"],"filterAroundRadius":2000,"filters":"string","facets":["string"],"customFilteredFacets":{"brand":"price > 100","price":"brand == foo"},"facetsSize":2000,"maxValuesPerFacet":50,"caseSensitiveFacetValues":false,"includeFacets":"all","facetsOrderBy":"coverage","context":["mobile","listing"],"displayAttributes":["title","price"],"distinctFilter":{"attribute":"string","maxNumItems":1,"levelRangeModifier":0},"ignoreQueryRules":false,"excludeQueryRules":[2,5],"params":{"source":"mobile"},"disableQueryClassification":false,"disableDynamicReranker":false}'

GET /search/v2/indices/{indexId}/autocomplete/explain — Explained autocomplete items search

/api-reference/ai-search#tag/Search/operation/SearchAutocompleteGetWithExplanation

Retrieves items that match a query from a search index or a suggestion index. The results can be filtered and sorted. The results of this search type are not cached. The response contains an explanation of the factors that influenced the result.


API consumers: AI API key (legacy), Web SDK Tracker, Workspace (Business Profile)

API key permission required: ITEMS_SEARCH_SEARCH_READ

Parameters

NameInTypeRequiredDescription
queryquerystringrequiredQuery text to use in the search
indexIdpathstringrequiredID of the index to be used in the search operation
clientUUIDquerystringoptionalUUID of the profile for which the search is performed
personalizequerybooleanoptionalIf set to false, the search result is not personalized.
sortByMetricqueryenum<"TransactionsPopularity", "PageVisitsPopularity">optionalIMPORTANT: Sorting disables boosting, elastic filters, and promoting search results. Name of the metric by which the data will be sorted.
sortByGeoPointquerystringoptionalIMPORTANT: Sorting disables boosting, elastic filters, and promoting search results. Geo-point ({latitude},{longitude}) for data sorting. Results are sorted by distance from this point. ordering: asc means "closest first".'
filterGeoPointsqueryarray<string>optionalThe definition of a geographical area to filter by. Given one geo-point, the results will be limited to a radius around a point. To override the default radius (1000 meters), provide the filterAroundRadius parameter. Example input: ["34.052235,-118.243685"] Given two geo-points, the results will be limited to a rectangular area. Example input: ["50,-100", "25,150"] Given three or more geo-points, the results will be limited to a polygonal area. Example input: ["50,0", "40,20", "-20,10"]
filterAroundRadiusqueryintegeroptionalRadius in meters to be used when filtering using geo-location. Can only be used when filtering by a single geo-point.
filtersquerystringoptionalIQL query string. For details, see the Help Center.
facetsqueryarray<string>optionalA list of attributes for which facets will be returned. A single * value matches all facetable attributes. A single auto value enables automatic facet selection based on the result set — the system picks the most relevant facets using the index's dynamicFacets configuration. To determine which groups of facets should be returned, use the includeFacets parameter.
facetsSizequeryintegeroptionalDetermines how many items will be used for facets aggregation.
maxValuesPerFacetqueryintegeroptionalDetermines how many values will be retrieved per facet.
caseSensitiveFacetValuesquerybooleanoptionalSpecifies whether facets aggregation should be case sensitive.
displayAttributesqueryarray<string>optionalList of ad hoc attributes that will be returned for each found item
contextqueryarray<string>optionalList of context strings for a search query
includeFacetsqueryenum<"all", "filtered", "unfiltered", "none">optionalDetermines which groups of facets will be returned: both filtered and unfiltered; just filtered; just unfiltered; or no group at at all. To determine which attributes should be returned as facets in each group, use the facets parameter.
facetsOrderByqueryenum<"coverage", "name">optionalControls the ordering of facets in the response.When facets=auto, the default ordering is by coverage (most relevant facets first).When facets are specified explicitly, the default ordering is by name.When two facets have equal coverage, ties are resolved by name.
pagequeryintegeroptionalPage number to return for pagination. The first page has the index 1.
limitqueryintegeroptionalThe number of items to return per page
sortByquerystringoptionalIMPORTANT: Sorting disables boosting, elastic filters, and promoting search results. Name of the attribute by which the data will be sorted.
orderingqueryenum<"desc", "asc">optionalSorting order
includeMetaquerybooleanoptionalWhen true, pagination metadata is included in the response body. When false, the data is included in the response headers: Link: links to neighbors, first, and last pages in pagination. X-Pagination-Total-Count: total number of items on all pages X-Pagination-Total-Pages: total number of pages X-Pagination-Page: current page X-Pagination-Limit: maximum number of items on a page X-Pagination-Sorted-By: parameter that the items were sorted by X-Pagination-Ordering: sorting direction
distinctFilterquerystringoptionalDistinctFilter JSON as an URL-encoded string
ignoreQueryRulesquerybooleanoptionalIf set to true, query rules are not applied.
excludeQueryRulesqueryarray<integer>optionalList of query rules that will not be applied.
crossWorkspaceModeEnabledquerybooleanoptionalIf set, overrides the cross-workspace mode from the index configuration. When true, cross-workspace personalization is enabled. When false, it is disabled.
paramsqueryarray<string>optionalList of extra params that will be added to the item.search event. They must be in the name:value format. The total size must not exceed 500 bytes when written as a JSON object.
disableQueryClassificationquerybooleanoptionalIf set to true, query classification is not applied.
disableDynamicRerankerquerybooleanoptionalIf set to true, dynamic reranker is not applied.

Responses

StatusDescription
200 application/jsonSearch result
500 application/jsonService not available

Example request (cURL)

curl --request GET \
  --url 'https://api.synerise.com/search/v2/indices/%7BindexId%7D/autocomplete/explain?query=SOME_STRING_VALUE&clientUUID=SOME_STRING_VALUE&personalize=SOME_BOOLEAN_VALUE&sortByMetric=SOME_STRING_VALUE&sortByGeoPoint=34.052235%2C-118.243685&filterGeoPoints=34.052235%2C-118.243685&filterGeoPoints=15.0%2C65.0&filterAroundRadius=5000&filters=SOME_STRING_VALUE&facets=SOME_ARRAY_VALUE&facetsSize=SOME_INTEGER_VALUE&maxValuesPerFacet=SOME_INTEGER_VALUE&caseSensitiveFacetValues=SOME_BOOLEAN_VALUE&displayAttributes=title&displayAttributes=price&context=mobile&context=listing&includeFacets=SOME_STRING_VALUE&facetsOrderBy=SOME_STRING_VALUE&page=4&limit=10&sortBy=SOME_STRING_VALUE&ordering=SOME_STRING_VALUE&includeMeta=SOME_BOOLEAN_VALUE&distinctFilter=%7B%22attribute%22%3A%20%22color%22%2C%20%22maxNumItems%22%3A%203%7D&ignoreQueryRules=SOME_BOOLEAN_VALUE&excludeQueryRules=2&excludeQueryRules=5&crossWorkspaceModeEnabled=SOME_BOOLEAN_VALUE&params=source%3Amobile&disableQueryClassification=SOME_BOOLEAN_VALUE&disableDynamicReranker=SOME_BOOLEAN_VALUE' \
  --header 'Authorization: Bearer REPLACE_BEARER_TOKEN'

POST /search/v2/indices/{indexId}/autocomplete/explain — Explained autocomplete items search

/api-reference/ai-search#tag/Search/operation/SearchAutocompletePostWithExplanation

Retrieves items that match a query from a search index or a suggestion index. The results can be filtered and sorted. The results of this search type are not cached. The response contains an explanation of the factors that influenced the result.


API consumers: AI API key (legacy), Web SDK Tracker, Workspace (Business Profile)

API key permission required: ITEMS_SEARCH_SEARCH_READ

Parameters

NameInTypeRequiredDescription
indexIdpathstringrequiredID of the index to be used in the search operation

Request body (required)

application/json · object

Request for performing an autocomplete search with explanation

FieldTypeRequiredDescription
querystringrequiredQuery text to use in the search
pageintegeroptionalPage number to return for pagination. The first page has the index 1.
limitintegeroptionalThe number of items to return per page
sortBystringoptionalIMPORTANT: Sorting disables boosting, elastic filters, and promoting search results. Name of the attribute by which the data will be sorted.
orderingenum<"desc", "asc">optionalSorting order
includeMetabooleanoptionalWhen true, pagination metadata is included in the response body. When false, the data is included in the response headers: Link: links to neighbors, first, and last pages in pagination. X-Pagination-Total-Count: total number of items on all pages X-Pagination-Total-Pages: total number of pages X-Pagination-Page: current page X-Pagination-Limit: maximum number of items on a page X-Pagination-Sorted-By: parameter that the items were sorted by X-Pagination-Ordering: sorting direction
clientUUIDstringoptionalUUID of the profile for which the search is performed
sortByMetricenum<"TransactionsPopularity", "PageVisitsPopularity">optionalIMPORTANT: Sorting disables boosting, elastic filters, and promoting search results. Name of the metric by which the data will be sorted.
sortByGeoPointsstringoptionalIMPORTANT: Sorting disables boosting, elastic filters, and promoting search results. Geo-point ({latitude},{longitude}) for data sorting. Results are sorted by distance from this point. ordering: asc means "closest first".'
filterGeoPointsarray<string>optionalThe definition of a geographical area to filter by. Given one geo-point, the results will be limited to a radius around a point. To override the default radius (1000 meters), provide the filterAroundRadius parameter. Example input: ["34.052235,-118.243685"] Given two geo-points, the results will be limited to a rectangular area. Example input: ["50,-100", "25,150"] Given three or more geo-points, the results will be limited to a polygonal area. Example input: ["50,0", "40,20", "-20,10"]
filterAroundRadiusintegeroptionalRadius in meters to be used when filtering using geo-location. Can only be used when filtering by a single geo-point.
filtersstringoptionalIQL query string. For details, see the Help Center.
facetsarray<string>optionalA list of attributes for which facets will be returned. A single * value matches all facetable attributes. A single auto value enables automatic facet selection based on the result set — the system picks the most relevant facets using the index's dynamicFacets configuration. To determine which groups of facets should be returned, use the includeFacets parameter.
customFilteredFacetsobjectoptionalA key-value map that takes attributes as keys and IQL query strings as values. For each key a facet is returned that includes only the items filtered by the provided IQL query string.
facetsSizeintegeroptionalDetermines how many items will be used for facets aggregation.
maxValuesPerFacetintegeroptionalDetermines how many values will be retrieved per facet.
caseSensitiveFacetValuesbooleanoptionalSpecifies whether facets aggregation should be case sensitive.
includeFacetsenum<"all", "filtered", "unfiltered", "none">optionalDetermines which groups of facets will be returned: both filtered and unfiltered; just filtered; just unfiltered; or no group at at all. To determine which attributes should be returned as facets in each group, use the facets and customFilteredFacets parameters.
facetsOrderByenum<"coverage", "name">optionalControls the ordering of facets in the response.When facets=auto, the default ordering is by coverage (most relevant facets first).When facets are specified explicitly, the default ordering is by name.When two facets have equal coverage, ties are resolved by name.
contextarray<string>optionalList of context strings for a search query
displayAttributesarray<string>optionalList of ad hoc attributes that will be returned for each found item
distinctFilterobjectoptionalDistinct filters regulate how many items with the same value of a particular attribute can be returned.
ignoreQueryRulesbooleanoptionalIf set to true, query rules are not applied.
excludeQueryRulesarray<integer>optionalList of query rules that will not be applied.
paramsobjectoptionalExtra parameters that will be added to the item.search event. The total size must not exceed 500 bytes.
disableQueryClassificationbooleanoptionalIf set to true, query classification is not applied.
disableDynamicRerankerbooleanoptionalIf set to true, q dynamic reranker is not applied.
crossWorkspaceModeobjectoptionalCross-workspace personalization mode. When provided, overrides the index configuration setting.

Responses

StatusDescription
200 application/jsonSearch result
500 application/jsonService not available

Example request (cURL)

curl --request POST \
  --url https://api.synerise.com/search/v2/indices/%7BindexId%7D/autocomplete/explain \
  --header 'Authorization: Bearer REPLACE_BEARER_TOKEN' \
  --header 'content-type: application/json' \
  --data '{"query":"string","page":0,"limit":10,"sortBy":"string","ordering":"desc","includeMeta":true,"clientUUID":"string","sortByMetric":"TransactionsPopularity","sortByGeoPoints":"34.052235,-118.243685","filterGeoPoints":["34.052235,-118.243685","15.0,65.0"],"filterAroundRadius":2000,"filters":"string","facets":["string"],"customFilteredFacets":{"brand":"price > 100","price":"brand == foo"},"facetsSize":2000,"maxValuesPerFacet":50,"caseSensitiveFacetValues":false,"includeFacets":"all","facetsOrderBy":"coverage","context":["mobile","listing"],"displayAttributes":["title","price"],"distinctFilter":{"attribute":"string","maxNumItems":1,"levelRangeModifier":0},"ignoreQueryRules":false,"excludeQueryRules":[2,5],"params":{"source":"mobile"},"disableQueryClassification":false,"disableDynamicReranker":false,"crossWorkspaceMode":{"enabled":true}}'

GET /search/v2/indices/{indexId}/explain-match — Searchable attributes match

/api-reference/ai-search#tag/Search/operation/searchableAttributesMatch

Enter a query and an item ID to check if a token (a word or a synonym which replaced it) matches a value or part of a value from the item's searchable attributes.


API consumers: Workspace (Business Profile), Synerise User

API key permission required: ITEMS_SEARCH_SEARCH_READ

User role permission required: assets_search: read

Parameters

NameInTypeRequiredDescription
indexIdpathstringrequiredID of the index to be used in the search operation
queryquerystringrequiredQuery text to use in the search
itemIdquerystringrequiredItem ID

Responses

StatusDescription
200 application/jsonSearchable attributes match result
500 application/jsonService not available

Example request (cURL)

curl --request GET \
  --url 'https://api.synerise.com/search/v2/indices/%7BindexId%7D/explain-match?query=SOME_STRING_VALUE&itemId=SOME_STRING_VALUE' \
  --header 'Authorization: Bearer REPLACE_BEARER_TOKEN'

GET /search/v2/indices/{indexId}/deleted-searches — Get deleted searches

/api-reference/ai-search#tag/Search/operation/GetDeletedSearches

Retrieve the searches deleted from a profile's history.


API consumers: AI API key (legacy), Workspace (Business Profile), Web SDK Tracker

API key permission required: ITEMS_SEARCH_RECENT_SEARCH_READ

Parameters

NameInTypeRequiredDescription
indexIdpathstringrequiredID of the index that the query relates to
clientUUIDquerystringrequiredUUID of the profile for which the query is performed

Responses

StatusDescription
200 application/jsonDeleted searches returned
400 application/jsonCheck error message for more details

Example request (cURL)

curl --request GET \
  --url 'https://api.synerise.com/search/v2/indices/4add1a1fa877c1651906bb22c9dfd37a1618852272/deleted-searches?clientUUID=e0097757-d1e2-44ac-ba3c-d97979a354c1' \
  --header 'Authorization: Bearer REPLACE_BEARER_TOKEN'

POST /search/v2/indices/{indexId}/deleted-searches — Soft-delete a recent search

/api-reference/ai-search#tag/Search/operation/PostDeletedSearch

Delete a recent search from the history accessible to a profile. The search remains in the database and you can retrieve it by using this endpoint.


API consumers: AI API key (legacy), Workspace (Business Profile), Web SDK Tracker

API key permission required: ITEMS_SEARCH_RECENT_SEARCH_CREATE

Parameters

NameInTypeRequiredDescription
indexIdpathstringrequiredID of the index that the query relates to
clientUUIDquerystringrequiredUUID of the profile for which the query is performed

Request body (required)

application/json · items-search-recent-DeletedSearch

Request for deleting search query

FieldTypeRequiredDescription
querystringoptionalDeleted search query. Required if match field is set to query.
matchstringoptionalTells how to match this deleted search on recent searches. query: matches only recent searches with provided query all: matches all recent searches
timestampstringoptionalTime when the search was deleted. If not present current time is taken.

Responses

StatusDescription
204Soft-delete successful
400 application/jsonCheck error message for more details

Example request (cURL)

curl --request POST \
  --url 'https://api.synerise.com/search/v2/indices/4add1a1fa877c1651906bb22c9dfd37a1618852272/deleted-searches?clientUUID=e0097757-d1e2-44ac-ba3c-d97979a354c1' \
  --header 'Authorization: Bearer REPLACE_BEARER_TOKEN' \
  --header 'content-type: application/json' \
  --data '{"query":"string","match":"query","timestamp":"2019-08-24T14:15:22Z"}'

GET /search/v2/indices/{indexId}/recent-searches — Get recent searches

/api-reference/ai-search#tag/Search/operation/GetRecentSearches

Get a profile's recent searches from a particular index.


API consumers: AI API key (legacy), Workspace (Business Profile), Web SDK Tracker

API key permission required: ITEMS_SEARCH_RECENT_SEARCH_READ

Parameters

NameInTypeRequiredDescription
indexIdpathstringrequiredID of the index that the query relates to
clientUUIDquerystringrequiredUUID of the profile for which the query is performed
windowSizequeryintegeroptionalMaximum number of recent searches to be returned. NOTE: The provided query parameter has priority over the configuration provided in this endpoint. If the parameter is not provided, the default value does not override the configuration.
timeUnitqueryenum<"YEARS", "MONTHS", "WEEKS", "DAYS", …>optionalThe time unit. Used in conjunction with timeValue.NOTE: The provided query parameter has priority over the configuration provided in this endpoint. If the parameter is not provided, the default value does not override the configuration.
timeValuequeryintegeroptionalThe amount of time units. Used in conjunction with timeUnit.NOTE: The provided query parameter has priority over the configuration provided in this endpoint. If the parameter is not provided, the default value does not override the configuration.

Responses

StatusDescription
200 application/jsonRecent searches returned
400 application/jsonCheck error message for more details

Example request (cURL)

curl --request GET \
  --url 'https://api.synerise.com/search/v2/indices/4add1a1fa877c1651906bb22c9dfd37a1618852272/recent-searches?clientUUID=e0097757-d1e2-44ac-ba3c-d97979a354c1&windowSize=SOME_INTEGER_VALUE&timeUnit=SOME_STRING_VALUE&timeValue=SOME_INTEGER_VALUE' \
  --header 'Authorization: Bearer REPLACE_BEARER_TOKEN'

Search Stats

GET /search/v2/indices/{indexId}/stats/queries/summary — Get queries stats summary

/api-reference/ai-search#tag/Search-Stats/operation/GetQueriesSummary

Retrieves the statistics of all queries or a single query defined in the request.


API consumers: Workspace (Business Profile), Synerise User

API key permission required: AI_STATS_READ

User role permission required: assets_search: read

Parameters

NameInTypeRequiredDescription
indexIdpathstringrequiredID of the index for which the stats are requested
dateFromquerystringoptionalUpper bound of the interval for which the statistics will be retrieved.Must be provided with to, otherwise the filter is treated as unspecified.If not specified, the interval is last 7 days.
dateToquerystringoptionalLower bound of the interval for which the statistics will be retrieved. If not specified, the interval is last 7 days.
queryquerystringoptionalQuery for which stats will be returned. If not provided, the results are returned for the most popular queries.
searchTypequeryenum<"fullTextSearch", "autocomplete", "listing", "visual", …>optionalSearch type for which stats will be retrieved.
groupByqueryenum<"date">optionalAttribute for which retrieved stats will be grouped.

Responses

StatusDescription
200 application/jsonStatistics returned
500 application/jsonService error
4xx application/jsonIncorrect request

Example request (cURL)

curl --request GET \
  --url 'https://api.synerise.com/search/v2/indices/4add1a1fa877c1651906bb22c9dfd37a1618852272/stats/queries/summary?dateFrom=SOME_STRING_VALUE&dateTo=SOME_STRING_VALUE&query=SOME_STRING_VALUE&searchType=SOME_STRING_VALUE&groupBy=SOME_STRING_VALUE' \
  --header 'Authorization: Bearer REPLACE_BEARER_TOKEN'

GET /search/v2/indices/{indexId}/stats/queries/top — Get top query statistics

/api-reference/ai-search#tag/Search-Stats/operation/GetQueriesTop

Retrieves the 1000 most popular queries.

IMPORTANT: Don't use this endpoint for displaying most popular queries to end users when they're searching. Instead, use search/v2/indices/{indexId}/list, where indexId is a suggestion index.


API consumers: Workspace (Business Profile), Synerise User, AI API key (legacy)

API key permission required: AI_STATS_READ

User role permission required: assets_search: read

Parameters

NameInTypeRequiredDescription
indexIdpathstringrequiredID of the index for which the stats are requested
dateFromquerystringoptionalUpper bound of the interval for which the statistics will be retrieved.Must be provided with to, otherwise the filter is treated as unspecified.If not specified, the interval is last 7 days.
dateToquerystringoptionalLower bound of the interval for which the statistics will be retrieved. If not specified, the interval is last 7 days.
queryquerystringoptionalQuery for which stats will be returned. If not provided, the results are returned for the most popular queries.
searchTypequeryenum<"fullTextSearch", "autocomplete", "listing", "visual", …>optionalSearch type for which stats will be retrieved.
queryFilterqueryenum<"queries", "queriesWithNoResults", "queriesWithUsedSuggestions">optionalQueries for which stats will be retrieved.
groupByqueryenum<"date">optionalAttribute for which retrieved stats will be grouped.
withFiltersqueryenum<true, false>optionalSwitch to display search statistics with enabled filters or without filters.
SortByqueryenum<"count", "clicks", "conversions", "clickThroughRate", …>optionalField by which results should be sorted.
orderingqueryenum<"asc", "desc">optionalSort order direction.

Responses

StatusDescription
200 application/jsonStatistics returned
500 application/jsonService error
4xx application/jsonIncorrect request

Example request (cURL)

curl --request GET \
  --url 'https://api.synerise.com/search/v2/indices/4add1a1fa877c1651906bb22c9dfd37a1618852272/stats/queries/top?dateFrom=SOME_STRING_VALUE&dateTo=SOME_STRING_VALUE&query=SOME_STRING_VALUE&searchType=SOME_STRING_VALUE&queryFilter=SOME_STRING_VALUE&groupBy=SOME_STRING_VALUE&withFilters=SOME_STRING_VALUE&SortBy=SOME_STRING_VALUE&ordering=SOME_STRING_VALUE' \
  --header 'Authorization: Bearer REPLACE_BEARER_TOKEN'

GET /search/v2/indices/{indexId}/stats/filters/summary — Get filters stats

/api-reference/ai-search#tag/Search-Stats/operation/GetFiltersSummary

Retrieves the statistics of filters used in searches.


API consumers: Workspace (Business Profile), Synerise User

API key permission required: AI_STATS_READ

User role permission required: assets_search: read

Parameters

NameInTypeRequiredDescription
indexIdpathstringrequiredID of the index for which the stats are requested
filterNamequerystringoptionalName of the filterable attribute. If present top values of this filter are returned.
dateFromquerystringoptionalUpper bound of the interval for which the statistics will be retrieved.Must be provided with to, otherwise the filter is treated as unspecified.If not specified, the interval is last 7 days.
dateToquerystringoptionalLower bound of the interval for which the statistics will be retrieved. If not specified, the interval is last 7 days.
groupByqueryenum<"date">optionalAttribute for which retrieved stats will be grouped.
orderingqueryenum<"asc", "desc">optionalSort order direction.

Responses

StatusDescription
200 application/jsonStatistics returned
500 application/jsonService error
4xx application/jsonIncorrect request

Example request (cURL)

curl --request GET \
  --url 'https://api.synerise.com/search/v2/indices/4add1a1fa877c1651906bb22c9dfd37a1618852272/stats/filters/summary?filterName=brand&dateFrom=SOME_STRING_VALUE&dateTo=SOME_STRING_VALUE&groupBy=SOME_STRING_VALUE&ordering=SOME_STRING_VALUE' \
  --header 'Authorization: Bearer REPLACE_BEARER_TOKEN'

GET /search/v2/indices/{indexId}/stats/rules/summary — Get rules stats

/api-reference/ai-search#tag/Search-Stats/operation/GetRulesSummary

Retrieves the statistics of applied rules.


API consumers: Workspace (Business Profile), Synerise User

API key permission required: AI_STATS_READ

User role permission required: assets_search: read

Parameters

NameInTypeRequiredDescription
indexIdpathstringrequiredID of the index for which the stats are requested
dateFromquerystringoptionalUpper bound of the interval for which the statistics will be retrieved.Must be provided with to, otherwise the filter is treated as unspecified.If not specified, the interval is last 7 days.
dateToquerystringoptionalLower bound of the interval for which the statistics will be retrieved. If not specified, the interval is last 7 days.
groupByqueryenum<"date">optionalAttribute for which retrieved stats will be grouped.

Responses

StatusDescription
200 application/jsonStatistics returned
500 application/jsonService error
4xx application/jsonIncorrect request

Example request (cURL)

curl --request GET \
  --url 'https://api.synerise.com/search/v2/indices/4add1a1fa877c1651906bb22c9dfd37a1618852272/stats/rules/summary?dateFrom=SOME_STRING_VALUE&dateTo=SOME_STRING_VALUE&groupBy=SOME_STRING_VALUE' \
  --header 'Authorization: Bearer REPLACE_BEARER_TOKEN'

GET /search/v2/indices/stats/queries/summary — Get queries summary for multiple indices

/api-reference/ai-search#tag/Search-Stats/operation/GetQueriesSummaryMultipleIndices

Retrieves the statistics of all queries or a single query defined in the request for multiple indices.


API consumers: Workspace (Business Profile), Synerise User

API key permission required: AI_STATS_READ

User role permission required: assets_search: read

Parameters

NameInTypeRequiredDescription
indexIdqueryarray<string>requiredList of indices ids for which the stats are requested.
dateFromquerystringoptionalUpper bound of the interval for which the statistics will be retrieved.Must be provided with to, otherwise the filter is treated as unspecified.If not specified, the interval is last 7 days.
dateToquerystringoptionalLower bound of the interval for which the statistics will be retrieved. If not specified, the interval is last 7 days.
queryquerystringoptionalQuery for which stats will be returned. If not provided, the results are returned for the most popular queries.
searchTypequeryenum<"fullTextSearch", "autocomplete", "listing", "visual", …>optionalSearch type for which stats will be retrieved.
groupByqueryenum<"date">optionalAttribute for which retrieved stats will be grouped.

Responses

StatusDescription
200 application/jsonStatistics returned
500 application/jsonService error
4xx application/jsonIncorrect request

Example request (cURL)

curl --request GET \
  --url 'https://api.synerise.com/search/v2/indices/stats/queries/summary?indexId=SOME_ARRAY_VALUE&dateFrom=SOME_STRING_VALUE&dateTo=SOME_STRING_VALUE&query=SOME_STRING_VALUE&searchType=SOME_STRING_VALUE&groupBy=SOME_STRING_VALUE' \
  --header 'Authorization: Bearer REPLACE_BEARER_TOKEN'

Recommendation campaigns

GET /recommendations/v2/campaigns — Get all recommendation campaigns

/api-reference/ai-recommendations#tag/Recommendation-campaigns/operation/GetRecommendationCampaignsV2

Fetch all recommendation campaigns.


API consumers: Workspace (Business Profile), Synerise User

API key permission required: RECOMMENDATIONS_V2_MANY_CAMPAIGN_READ

User role permission required: campaigns_recommendations: read

Parameters

NameInTypeRequiredDescription
pagequeryintegeroptionalPage number
limitqueryintegeroptionalMaximum number of campaigns on a page
sortByqueryenum<"createdAt", "updatedAt", "startDate", "endDate", …>optionalName of the field by which data will be sorted
orderingqueryenum<"asc", "desc">optionalSorting order
includeMetaquerybooleanoptionalIf true, a meta JSON block with pagination data is included in the response body. If false, the pagination data is included in the response headers.
typequerystringoptionalFilters the results by campaign type.
statequeryarray<enum<"draft", "active", "paused">>optionalShows only results with states matching this parameter. When this parameter is omitted, all campaigns are returned regardless of state.
searchquerystringoptionalSearches campaigns by the specified phrase in their id and title.

Responses

StatusDescription
200 application/jsonReturns paginated campaigns. If showMeta was set to true, the metadata is included in the JSON response. If it was set to false, the metadata is included in the headers.
404 application/jsonCould not find campaigns
500 application/jsonAn error occurred

Example request (cURL)

curl --request GET \
  --url 'https://api.synerise.com/recommendations/v2/campaigns?page=SOME_INTEGER_VALUE&limit=SOME_INTEGER_VALUE&sortBy=SOME_STRING_VALUE&ordering=SOME_STRING_VALUE&includeMeta=SOME_BOOLEAN_VALUE&type=SOME_STRING_VALUE&state=SOME_ARRAY_VALUE&search=SOME_STRING_VALUE' \
  --header 'Authorization: Bearer REPLACE_BEARER_TOKEN'

POST /recommendations/v2/campaigns — Create a recommendation campaign

/api-reference/ai-recommendations#tag/Recommendation-campaigns/operation/CreateRecommendationCampaignV2

Create a new recommendation campaign.


API consumers: Workspace (Business Profile), Synerise User

API key permission required: RECOMMENDATIONS_V2_CAMPAIGN_CREATE

User role permission required: campaigns_recommendations: create

Request body (required)

application/json · object

All the details of a campaign

Responses

StatusDescription
200 application/jsonOK campaign has been returned
500 application/jsonAn error occurred

Example request (cURL)

curl --request POST \
  --url https://api.synerise.com/recommendations/v2/campaigns \
  --header 'Authorization: Bearer REPLACE_BEARER_TOKEN' \
  --header 'content-type: application/json' \
  --data '{"type":"similar","parameters":{"additionalResponseAttributes":["string"],"boostMetric":"string","sortMetric":"string","boostMetricStrength":-100,"shuffleNumItems":0,"personalizedBoostingStrength":0},"title":"string","slug":"string","description":"string","startDate":"string","endDate":"string","state":"draft","filterRules":{"excludePurchasedItems":true,"excludePurchasedItemsSinceDays":0,"elasticExcludePurchasedItems":true,"elasticExcludePurchasedItemsSinceDays":0},"itemsCatalogId":"string","slots":[{"name":"string","itemMin":0,"itemMax":0,"filterRules":{"filters":"string","elasticFilters":"string"},"distinctFilter":{"elastic":true,"filters":[{"field":"string","maxNumItems":0,"levelRangeModifier":0}]},"attribute":{"name":"string","levelRangeModifier":0},"numRows":0,"numItems":0,"useDefaultDistinctFilters":true,"useDefaultItemFilters":true}],"keepSlotsOrder":true,"personalizeSlotsOrder":false,"boostingStrategies":[{"name":"string","condition":"string","strength":1}],"itemsSource":{"type":"aggregate","id":"string"}}'

GET /recommendations/v2/campaigns/{campaignId} — Get recommendation campaign details

/api-reference/ai-recommendations#tag/Recommendation-campaigns/operation/GetRecommendationCampaignV2

Retrieve the details of a single campaign.


API consumers: Workspace (Business Profile), Synerise User

API key permission required: RECOMMENDATIONS_V2_SINGLE_CAMPAIGN_READ

User role permission required: campaigns_recommendations: read

Parameters

NameInTypeRequiredDescription
campaignIdpathstringrequiredID of the campaign

Responses

StatusDescription
200 application/jsonData of a single campaign
404 application/jsonCould not find campaign
500 application/jsonAn error occurred

Example request (cURL)

curl --request GET \
  --url https://api.synerise.com/recommendations/v2/campaigns/%7BcampaignId%7D \
  --header 'Authorization: Bearer REPLACE_BEARER_TOKEN'

POST /recommendations/v2/campaigns/{campaignId} — Update a recommendation campaign

/api-reference/ai-recommendations#tag/Recommendation-campaigns/operation/UpdateRecommendationCampaignV2

Update a recommendation campaign by changing the parameters or copying the definition from another campaign.

When you copy from another campaign:

  • the following campaign data is NOT updated:
    • title
    • state
    • start_date
    • end_date
    • campaignId
    • createdAt
  • modified_by_user_id changes to the user who performed the update

API consumers: Workspace (Business Profile), Synerise User

API key permission required: RECOMMENDATIONS_V2_CAMPAIGN_UPDATE

User role permission required: campaigns_recommendations: update

Parameters

NameInTypeRequiredDescription
campaignIdpathstringrequiredID of the campaign

Request body (required)

application/json · recommendation-campaigns-RecommendationCampaignUpdateRequest

Definition of the updated campaign.

FieldTypeRequiredDescription
copyConfigurationFromstringrequiredSource campaign ID. When you copy from another campaign: the following campaign data is NOT updated: title state start_date end_date campaignId createdAt modified_by_user_id changes to the user who performed the update

Responses

StatusDescription
200 application/jsonCampaign updated and returned
404 application/jsonCould not find campaign
500 application/jsonAn error occurred

Example request (cURL)

curl --request POST \
  --url https://api.synerise.com/recommendations/v2/campaigns/%7BcampaignId%7D \
  --header 'Authorization: Bearer REPLACE_BEARER_TOKEN' \
  --header 'content-type: application/json' \
  --data '{"type":"similar","parameters":{"additionalResponseAttributes":["string"],"boostMetric":"string","sortMetric":"string","boostMetricStrength":-100,"shuffleNumItems":0},"campaignId":"string","title":"string","slug":"string","description":"string","startDate":"string","endDate":"string","createdAt":"string","updatedAt":"string","state":"draft","filterRules":{"excludePurchasedItems":true,"excludePurchasedItemsSinceDays":0,"elasticExcludePurchasedItems":true,"elasticExcludePurchasedItemsSinceDays":0},"itemsCatalogId":"string","additionalResponseAttributes":["string"],"slots":[{"name":"string","itemMin":0,"itemMax":0,"filterRules":{"filters":"string","elasticFilters":"string"},"distinctFilter":{"elastic":true,"filters":[{"field":"string","maxNumItems":0,"levelRangeModifier":0}]},"attribute":{"name":"string","levelRangeModifier":0},"numRows":0,"numItems":0,"useDefaultDistinctFilters":true,"useDefaultItemFilters":true}],"keepSlotsOrder":true,"personalizeSlotsOrder":false,"boostingStrategies":[{"name":"string","condition":"string","strength":1}],"itemsSource":{"type":"aggregate","id":"string"},"abTest":{"experimentId":0,"variantId":0,"status":"NotStarted","isBaseline":true},"crossWorkspaceMode":{"enabled":true}}'

DELETE /recommendations/v2/campaigns/{campaignId} — Delete a recommendation campaign

/api-reference/ai-recommendations#tag/Recommendation-campaigns/operation/DeleteRecommendationCampaign

Delete a recommendation campaign. This operation is irreversible.


API consumers: Workspace (Business Profile), Synerise User

API key permission required: RECOMMENDATIONS_V2_CAMPAIGN_DELETE

User role permission required: campaigns_recommendations: delete

Parameters

NameInTypeRequiredDescription
campaignIdpathstringrequiredID of the campaign

Responses

StatusDescription
200 application/jsonOK campaign has been deleted
404 application/jsonCould not find campaign
500 application/jsonAn error occurred

Example request (cURL)

curl --request DELETE \
  --url https://api.synerise.com/recommendations/v2/campaigns/%7BcampaignId%7D \
  --header 'Authorization: Bearer REPLACE_BEARER_TOKEN'

POST /recommendations/v2/campaigns/state — Change campaigns' states

/api-reference/ai-recommendations#tag/Recommendation-campaigns/operation/UpdateRecommendationsStatesV2

Change the status of one or more campaigns.


API consumers: Workspace (Business Profile), Synerise User

API key permission required: RECOMMENDATIONS_V2_STATE_CAMPAIGN_UPDATE

User role permission required: campaigns_recommendations: update

Request body (required)

application/json · recommendation-campaigns-RecommendationStateChangeRequestV2

List of updated campaign IDs and new states.

FieldTypeRequiredDescription
stateenum<"draft", "active", "paused", "deleted">requiredCampaign status
idsarray<string>requiredAn array of campaign IDs.

Responses

StatusDescription
200 application/jsonCampaigns status changed
500 application/jsonAn error occurred

Example request (cURL)

curl --request POST \
  --url https://api.synerise.com/recommendations/v2/campaigns/state \
  --header 'Authorization: Bearer REPLACE_BEARER_TOKEN' \
  --header 'content-type: application/json' \
  --data '{"state":"draft","ids":["string"]}'

POST /recommendations/v2/campaigns/{campaignId}/copy — Copy a recommendation campaign

/api-reference/ai-recommendations#tag/Recommendation-campaigns/operation/CopyRecommendationCampaignV2

Copy a campaign. The copied campaign's state will be draft and slug will be undefined.


API consumers: Workspace (Business Profile), Synerise User

API key permission required: RECOMMENDATIONS_V2_COPY_CAMPAIGN_CREATE

User role permission required: campaigns_recommendations: create

Parameters

NameInTypeRequiredDescription
campaignIdpathstringrequiredID of the campaign

Responses

StatusDescription
200 application/jsonCopy created and returned
404 application/jsonCould not find campaign
500 application/jsonAn error occurred

Example request (cURL)

curl --request POST \
  --url https://api.synerise.com/recommendations/v2/campaigns/%7BcampaignId%7D/copy \
  --header 'Authorization: Bearer REPLACE_BEARER_TOKEN'

GET /recommendations/v2/campaigns/simplified — Get simplified recommendation campaigns

/api-reference/ai-recommendations#tag/Recommendation-campaigns/operation/GetSimplifiedRecommendationCampaign

Fetch simplified recommendation campaign data.


API consumers: Workspace (Business Profile), Synerise User

API key permission required: RECOMMENDATIONS_V2_MANY_SIMPLIFIED_CAMPAIGN_READ

User role permission required: campaigns_recommendations: read

Parameters

NameInTypeRequiredDescription
typequeryarray<string>optionalFilter by campaign type.
statequeryarray<enum<"draft", "active", "paused">>optionalFilter by states.

Responses

StatusDescription
200 application/jsonSimplified campaigns returned
404 application/jsonCould not find campaign
500 application/jsonAn error occurred

Example request (cURL)

curl --request GET \
  --url 'https://api.synerise.com/recommendations/v2/campaigns/simplified?type=SOME_ARRAY_VALUE&state=SOME_ARRAY_VALUE' \
  --header 'Authorization: Bearer REPLACE_BEARER_TOKEN'

Recommendation statistics

POST /recommendations/v2/campaigns/stats — Get recommendation campaign statistics

/api-reference/ai-recommendations#tag/Recommendation-statistics/operation/PostCampaignsStats

Retrieves the statistics of campaigns defined in the request.


API consumers: Workspace (Business Profile), Synerise User

API key permission required: AI_STATS_READ

User role permission required: campaigns_recommendations: read

Request body (required)

application/json · object

Request for recommendation campaigns stats.

FieldTypeRequiredDescription
campaignIdsarray<string>requiredList of campaign IDs for which the statistics are requested. Must not be empty.
fromstringoptionalUpper bound of the interval for which the statistics will be retrieved.Must be provided with to, otherwise the filter is treated as unspecified.If not specified, the interval is last 7 days.
tostringoptionalLower bound of the interval for which the statistics will be retrieved.Must be provided with from, otherwise the filter is treated as unspecified.If not specified, the interval is last 7 days.
timeZonestringoptionalTime zone identifier.

Responses

StatusDescription
200 application/jsonStatistics returned
500 application/jsonService error
4xx application/jsonIncorrect request

Example request (cURL)

curl --request POST \
  --url https://api.synerise.com/recommendations/v2/campaigns/stats \
  --header 'Authorization: Bearer REPLACE_BEARER_TOKEN' \
  --header 'content-type: application/json' \
  --data '{"campaignIds":["string"],"from":"2019-08-24","to":"2019-08-24","timeZone":"Europe/Warsaw"}'

GET /recommendations/v2/campaigns/stats/global — Get global recommendation campaign statistics

/api-reference/ai-recommendations#tag/Recommendation-statistics/operation/GetCampaignsGlobalStats

Retrieves the statistics of all recommendation campaigns.


API consumers: Workspace (Business Profile), Synerise User

API key permission required: AI_STATS_READ

User role permission required: campaigns_recommendations: read

Parameters

NameInTypeRequiredDescription
fromquerystringoptionalUpper bound of the interval for which the statistics will be retrieved.Must be provided with from, otherwise the filter is treated as unspecified.If not specified, the interval is last 7 days.
toquerystringoptionalLower bound of the interval for which the statistics will be retrieved. If not specified, the interval is last 7 days.
timeZonequerystringoptionalTime zone identifier.

Responses

StatusDescription
200 application/jsonStatistics returned
500 application/jsonService error
4xx application/jsonIncorrect request

Example request (cURL)

curl --request GET \
  --url 'https://api.synerise.com/recommendations/v2/campaigns/stats/global?from=SOME_STRING_VALUE&to=SOME_STRING_VALUE&timeZone=Europe%2FWarsaw' \
  --header 'Authorization: Bearer REPLACE_BEARER_TOKEN'

GET /recommendations/v2/campaigns/{campaignId}/stats — Get recommendation campaign statistics

/api-reference/ai-recommendations#tag/Recommendation-statistics/operation/GetCampaignStats

Retrieves the statistics of a single recommendation campaign.


API consumers: Workspace (Business Profile), Synerise User

API key permission required: AI_STATS_READ

User role permission required: campaigns_recommendations: read

Parameters

NameInTypeRequiredDescription
campaignIdpathstringrequiredID of the recommendation campaign
fromquerystringoptionalUpper bound of the interval for which the statistics will be retrieved.Must be provided with from, otherwise the filter is treated as unspecified.If not specified, the interval is last 7 days.
toquerystringoptionalLower bound of the interval for which the statistics will be retrieved. If not specified, the interval is last 7 days.
timeZonequerystringoptionalTime zone identifier.

Responses

StatusDescription
200 application/jsonStatistics returned
500 application/jsonService error
4xx application/jsonIncorrect request

Example request (cURL)

curl --request GET \
  --url 'https://api.synerise.com/recommendations/v2/campaigns/50NCGoRK0VRb/stats?from=SOME_STRING_VALUE&to=SOME_STRING_VALUE&timeZone=Europe%2FWarsaw' \
  --header 'Authorization: Bearer REPLACE_BEARER_TOKEN'

GET /recommendations/v2/campaigns/{campaignId}/products/stats — Get statistics for top items in a campaign

/api-reference/ai-recommendations#tag/Recommendation-statistics/operation/GetRecoTopProductsStats

Retrieves the statistics of top products for a single recommendation campaign.


API consumers: Workspace (Business Profile), Synerise User

API key permission required: AI_STATS_READ

User role permission required: campaigns_recommendations: read

Parameters

NameInTypeRequiredDescription
campaignIdpathstringrequiredID of the recommendation campaign
fromquerystringoptionalUpper bound of the interval for which the statistics will be retrieved.Must be provided with from, otherwise the filter is treated as unspecified.If not specified, the interval is last 7 days.
toquerystringoptionalLower bound of the interval for which the statistics will be retrieved. If not specified, the interval is last 7 days.
timeZonequerystringoptionalTime zone identifier.
metricqueryenum<"views", "clicks", "revenue", "generations", …>optionalThe response will include statistics for up to 10 top-performing items according to the selected metric, sorted from best to worst. If not specified, the default metric is views. views - the number of displayed recommendation frames. generations - the number of generated recommendation frames. clicks - the number of times an item in a recommendation frame was clicked. charges - the number of transactions caused by the recommendation. revenue - the revenue generated by the recommendation.

Responses

StatusDescription
200 application/jsonStatistics returned
500 application/jsonService error
4xx application/jsonIncorrect request

Example request (cURL)

curl --request GET \
  --url 'https://api.synerise.com/recommendations/v2/campaigns/50NCGoRK0VRb/products/stats?from=SOME_STRING_VALUE&to=SOME_STRING_VALUE&timeZone=Europe%2FWarsaw&metric=SOME_STRING_VALUE' \
  --header 'Authorization: Bearer REPLACE_BEARER_TOKEN'

Recommendations

GET /recommendations/v2/recommend/campaigns/{campaignIdentifier} — Get recommendations by campaign

/api-reference/ai-recommendations#tag/Recommendations/operation/GetRecommendationsByCampaignV2

This method allows you to retrieve recommendations based on a campaignID or a slug and a context. The context is built based on:

  • campaign identifier (required)
  • profile UUID
  • items (for example, items currently in the basket)
  • item exclusions

This is the recommended and simplest way to fetch recommendations.

Before you use this method, you must to create a recommendations campaign in Synerise. All the recommendation filters and parameters will be handled for you automatically according to a campaign's configuration.


API consumers: AI API key (legacy), Web SDK Tracker, Workspace (Business Profile)

API key permission required: API_MATERIALIZER_V2_RECOMMEND_CAMPAIGNS_RECOMMENDATIONS_READ

Parameters

NameInTypeRequiredDescription
campaignIdentifierpathstringrequiredRecommendation campaign identifier - a campaignID or a slug
clientUUIDquerystringoptionalProfile UUID. This parameter is required for these recommendation types: Personalized Last seen Recent interactions Section Attribute This parameter can be passed in all recommendations. In recommendations which don't require the customer context, it can still be used to create filters.
itemIdquerystringoptionalItem ID or item IDs for the recommendation context. This parameter is: required for similar/complementary items campaigns. optional for personalized campaigns. This parameter can be passed in all recommendations. In recommendations which don't use the context item as part of the recommendation model, the context item can only be used to create filters. You can repeat this parameter in order to pass a number of context-creating items, for example, in a cart recommendation campaign. This overrides the itemsSource settings of the campaign definition. Alternatively, you can pass the itemsSourceType and itemsSourceId parameters to use context items from source (aggregate or expression). These parameters can't be used at the same request with itemId.
inventoryChannelIdquerystringoptionalInventory context identifier used to evaluate inventory-related filters and boosting strategies. If not provided, no inventory context will be applied.
itemsSourceTypequeryenum<"aggregate", "expression">optionalItem ID or item IDs source type for the recommendation context. Must be used with itemSourceId. This overrides the itemsSource settings of the campaign definition. In recommendations whose models doesn't use the item context, the attributes of those items can only be used in filters. If the items' source type is 'aggregate', the aggregate result will be used as context items. If the items' source type is 'expression', the expression result will be used as context items. The item ID source (aggregate or expression) should return a string or an array of strings. If it returns numerical values, the recommendations engine attempts to convert them into strings while processing the request. Alternatively, you can pass the itemId parameter to define context items directly. Only one of these options is allowed at the same time.
itemsSourceIdquerystringoptionalSource of item IDs for the recommendation context. In recommendations whose models doesn't use the item context, the attributes of those items can only be used in filters. Must be used with itemsSourceType. If the items' source type is 'aggregate', this is the aggregate's ID. If the items' source type is 'expression', this is the expression's ID. The item ID source (aggregate or expression) should return a string or an array of strings. If it returns numerical values, the recommendations engine attempts to convert them into strings while processing the request. Alternatively, you can pass the itemId parameter to define context items directly. Only one of these options is allowed at the same time.
externalItemIdquerystringoptionalItems provided by an external recommendation model to be returned as recommendation results. You can repeat this parameter to pass multiple external items. This parameter is used with campaigns of type "external-items".
itemIdExcludedquerystringoptionalIDs of items that will be excluded from the generated recommendations. For example, items already added to the basket.
additionalFiltersquerystringoptional IMPORTANT: The filtersJoiner attribute is REQUIRED when additionalFilters is included. If filtersJoiner is missing, the additional filters do not work. Do NOT send multiple instances of this parameter. Additional filters. These are merged with the campaign's own filters according to the logic in filtersJoiner. This parameter must include all the additional filters as a single string, for example additionalFilters=effectivePrice>300 AND effectivePrice<400 (the spaces are required).
filtersJoinerqueryenum<"AND", "OR", "REPLACE">optionalDefines the logic of merging additionalFilters with the campaign's existing filters. REPLACE replaces the campaign's filters with your filters. AND matches if both your filters and the campaign filters are met. OR matches if at least one of the filters is met.
additionalElasticFiltersquerystringoptional IMPORTANT: The elasticFiltersJoiner attribute is REQUIRED when additionalElasticFilters is included. If elasticFiltersJoiner is missing, the additional filters do not work. Do NOT send multiple instances of this parameter. Additional elastic filters. These are merged with the campaign's own elastic filters according to the logic in elasticFiltersJoiner. This parameter must include all the additional filters as a single string, for example additionalElasticFilters=effectivePrice>300 AND effectivePrice<400 (the spaces are required).
elasticFiltersJoinerqueryenum<"AND", "OR", "REPLACE">optionalDefines the logic of merging additionalElasticFilters with the campaign's existing elastic filters. REPLACE replaces the campaign's filters with your filters. AND matches if both your filters and the campaign filters are met. OR matches if at least one of the filters is met.
displayAttributequerystringoptionalItem attribute whose value will be returned in the recommendation response. The parameter value will be merged with the configuration of the recommendation. This parameter can be passed multiple times.
includeContextItemsquerybooleanoptionalWhen true, the recommendation response will include context items metadata.
paramsqueryarray<string>optionalList of extra params that will be added to the recommendation.generated event. They must be in the name:value format. The total size must not exceed 500 bytes when written as a JSON object.

Responses

StatusDescription
200 application/jsonRecommendations for the provided context. The response schema depends on your Workspace configuration. The schema below only includes the static elements.
404 application/jsonNo recommendations could be generated for the specified campaign and context.
500 application/jsonAn error occurred

Example request (cURL)

curl --request GET \
  --url 'https://api.synerise.com/recommendations/v2/recommend/campaigns/%7BcampaignIdentifier%7D?clientUUID=SOME_STRING_VALUE&itemId=SOME_STRING_VALUE&inventoryChannelId=SOME_STRING_VALUE&itemsSourceType=SOME_STRING_VALUE&itemsSourceId=SOME_STRING_VALUE&externalItemId=SOME_STRING_VALUE&itemIdExcluded=SOME_STRING_VALUE&additionalFilters=effectivePrice%3E300%20AND%20effectivePrice%3C400&filtersJoiner=SOME_STRING_VALUE&additionalElasticFilters=effectivePrice%3E300%20AND%20effectivePrice%3C400&elasticFiltersJoiner=SOME_STRING_VALUE&displayAttribute=SOME_STRING_VALUE&includeContextItems=SOME_BOOLEAN_VALUE&params=source%3Amobile' \
  --header 'Authorization: Bearer REPLACE_BEARER_TOKEN'

POST /recommendations/v2/recommend/campaigns — Get recommendations by campaign

/api-reference/ai-recommendations#tag/Recommendations/operation/PostRecommendationsByCampaignV2

This method allows you to retrieve recommendations based on a campaignID or slug and a context. The context is built based on:

  • campaign ID or slug (one of those is required)
  • profile UUID
  • items (for example, items currently in the basket)
  • item exclusions

This is the recommended and simplest way to fetch recommendations.

Before you use this method, you must to create a recommendations campaign in Synerise. All the recommendation filters and parameters will be handled for you automatically according to a campaign's configuration.


API consumers: AI API key (legacy), Web SDK Tracker, Workspace (Business Profile)

API key permission required: API_MATERIALIZER_V2_RECOMMEND_CAMPAIGNS_RECOMMENDATIONS_READ

Request body

application/json · recommendations-api-materializer-PostRecommendationsRequest

FieldTypeRequiredDescription
clientUUIDstringoptionalProfile UUID. This parameter is required for these recommendation types: Personalized Last seen Recent interactions Section Attribute This parameter can be passed in all recommendations. In recommendations which don't require the customer context, it can still be used to create filters.
campaignIdstringoptionalRecommendation campaign ID for establishing the context
slugstringoptionalRecommendation campaign slug for establishing the context
itemsarray<string>optionalAn array of item identifiers (itemId in the item feed) for the context. This could be, for example, the current basket, or the item that is currently being viewed. This overrides the itemsSource settings of the campaign definition. This parameter can be passed in all recommendations. In recommendations which don't use the context item as part of the recommendation model, the context item can only be used to create filters. Alternatively, you can use the itemsSource object to get item IDs from an aggregate or expression. items and itemsSource can't be used at the same time.
itemsSourceobjectoptionalSource of the Item ID or item IDs for the recommendation context. This overrides the itemsSource settings of the campaign definition. This parameter can be passed in all recommendations. In recommendations which don't use the context item as part of the recommendation model, the context item can only be used to create filters. The item ID source (aggregate or expression) should return a string or an array of strings. If it returns numerical values, the recommendations engine attempts to convert them into strings while processing the request. Alternatively, you can pass the itemId parameter to define context items directly. Only one of these options is allowed at the same time.
itemsExcludedarray<string>optionalItems (identified by itemId in the item feed) that will be excluded from the generated recommendations. For example, items already added to the basket.
additionalFiltersstringoptional IMPORTANT: The filtersJoiner attribute is REQUIRED when additionalFilters is included. If filtersJoiner is missing, the additional filters do not work. Do NOT send multiple instances of this parameter. Additional filters. These are merged with the campaign's own filters according to the logic in filtersJoiner. This parameter must include all the additional filters as a single string, for example additionalFilters=effectivePrice>300 AND effectivePrice<400 (the spaces are required).
filtersJoinerenum<"AND", "OR", "REPLACE">optionalDefines the logic of merging additionalFilters with the campaign's existing filters. REPLACE replaces the campaign's filters with your filters. AND matches if both your filters and the campaign filters are met. OR matches if at least one of the filters is met.
additionalElasticFiltersstringoptional IMPORTANT: The elasticFiltersJoiner attribute is REQUIRED when additionalElasticFilters is included. If elasticFiltersJoiner is missing, the additional filters do not work. Do NOT send multiple instances of this parameter. Additional elastic filters. These are merged with the campaign's own elastic filters according to the logic in elasticFiltersJoiner. This parameter must include all the additional filters as a single string, for example additionalElasticFilters=effectivePrice>300 AND effectivePrice<400 (the spaces are required).
elasticFiltersJoinerenum<"AND", "OR", "REPLACE">optionalDefines the logic of merging additionalElasticFilters with the campaign's existing elastic filters. REPLACE replaces the campaign's filters with your filters. AND matches if both your filters and the campaign filters are met. OR matches if at least one of the filters is met.
displayAttributesarray<string>optionalAn array of item attributes which value will be returned in a recommendation response. The array will be merged together with the configuration of the recommendation.
includeContextItemsbooleanoptionalWhen true, the recommendation response will include context items metadata.
recommendedItemsFromExternalModelarray<array<string>>optionalItems provided by an external recommendation model to be returned as recommendation results. This parameter is used with campaigns of type "external-items".
[...]
